<?php
defined('WEKIT_VERSION') || exit('Forbidden');

/**
 * ϴ
 *
 * @author BiangBiang <biangbiangguoguo@163.com>
 * @copyright ?2003-2103 UpYun.com
 * @license https://www.upyun.com
 * @version $Id: App_Upyunupload_Storage.php  2012-12-18 BiangBiang $
 * @package upload
 */

require_once EXT_PATH . "./upyunupload/service/sdk/upyun.class.php";

class App_Upyunupload_Storage {

	private $_config;
	private $_upyun = null;
    private $api_access = array(UpYun::ED_AUTO, UpYun::ED_TELECOM, UpYun::ED_CNC, UpYun::ED_CTT);

	public function __construct() {
		$this->_config = Wekit::C('attachment');
        $dir = $this->_config['upyun.dir'];
        $url = $dir == "" ? "" : "/$dir";
        $this->_config['upyun.url'] = $this->_config['upyun.url'].$url;
        $this->_config['upyun.dir'] = $dir == "" ? "." : $dir;
        $this->_config['upyun.access'] = intval($this->_config['upyun.access']);
        $this->_config['upyun.access'] = $this->api_access[$this->_config['upyun.access']];
	}
	
	/**
	 * ȡwebַ
	 *
	 * @param string $path Դ洢ַ
	 * @param int $ifthumb Ƿȡͼ
	 * @return string
	 */
	public function get($path, $ifthumb) {
		$dir = '';
		if ($ifthumb & 2) {
			$dir = 'thumb/mini/';
		} elseif ($ifthumb & 1) {
			$dir = 'thumb/';
		}
		return $this->_config['upyun.url'] . '/' . $dir . $path;
	}
	
	/**
	 * ȡصַ
	 *
	 * @param string $path
	 * @return string ļʵ洢·
	 */
	public function getDownloadUrl($path) {
		return $this->get($path, 0);
	}
	
	/**
	 * 洢,Զ̴洢ǵɾļ
	 *
	 * @param string $source Դļַ
	 * @param string $filePath 洢λ
	 * @return bool
	 */
	public function save($source, $filePath) {
        try{
            if($fh = fopen($source,'rb')){
            $rsp = $this->_getUpyun()->writeFile('/' . $this->_config['upyun.dir'] . '/' . $filePath,$fh,True);
            fclose($fh);
            Pw::deleteFile($source);
            return true;
            }else{
                return false;
            }
        }
        catch(Exception $e){
            return false;
        }
	}
	
	/**
	 * ȡϴʱ洢ڱصļַ
	 *
	 * @param string $filename ļ
	 * @param string $dir Ŀ¼
	 * @return string
	 */
	public function getAbsolutePath($filename, $dir) {
		return DATA_PATH . 'upload/' . Pw::time2str(WEKIT_TIMESTAMP, 'j') . '/' . str_replace('/', '_', $dir) . $filename;
	}
	
	/**
	 * ɾ
	 *
	 * @param string $path ַ
	 */
	public function delete($path, $ifthumb = 0) {
        try{
            $this->_getUpyun()->delete('/' . $this->_config['upyun.dir'] . '/' . $path);
            if ($ifthumb) {
                ($ifthumb & 1) && $this->_getUpyun()->delete('/' . $this->_config['upyun.dir'] . '/' . 'thumb/' . $path);
                ($ifthumb & 2) && $this->_getUpyun()->delete('/' . $this->_config['upyun.dir'] . '/' . 'thumb/mini/' . $path);
            }
            return true;
        }
        catch(Exception $e){
            return false;
        }
	}

	public function _getUpyun() {
		if ($this->_upyun == null) {
			$this->_upyun = new UpYun($this->_config['upyun.bucket'],$this->_config['upyun.user'],$this->_config['upyun.pwd'],$this->_config['upyun.access']);
		}
		return $this->_upyun;
	}
}
?>
